Index: apps/app_dial.c
===================================================================
--- apps/app_dial.c	(revision 134653)
+++ apps/app_dial.c	(working copy)
@@ -1675,42 +1675,10 @@
 				goto out;
 			}
 		}
-		if (!ast_test_flag64(&opts, OPT_ANNOUNCE) || ast_strlen_zero(opt_args[OPT_ARG_ANNOUNCE])) {
-			res = 0;
-		} else {
-			int digit = 0;
-			/* Start autoservice on the other chan */
-			res = ast_autoservice_start(chan);
-			/* Now Stream the File */
-			if (!res)
-				res = ast_streamfile(peer, opt_args[OPT_ARG_ANNOUNCE], peer->language);
-			if (!res) {
-				digit = ast_waitstream(peer, AST_DIGIT_ANY);
-			}
-			/* Ok, done. stop autoservice */
-			res = ast_autoservice_stop(chan);
-			if (digit > 0 && !res)
-				res = ast_senddigit(chan, digit, 0);
-			else
-				res = digit;
 
-		}
+		ast_log(LOG_NOTICE, "ast_test_flag64(&opts, OPT_CALLEE_MACRO) && !ast_strlen_zero(opt_args[OPT_ARG_CALLEE_MACRO])\n");
+		ast_log(LOG_NOTICE, "%d && %d\n", !!ast_test_flag64(&opts, OPT_CALLEE_MACRO), !ast_strlen_zero(opt_args[OPT_ARG_CALLEE_MACRO]));
 
-		if (chan && peer && ast_test_flag64(&opts, OPT_GOTO) && !ast_strlen_zero(opt_args[OPT_ARG_GOTO])) {
-			replace_macro_delimiter(opt_args[OPT_ARG_GOTO]);
-			ast_parseable_goto(chan, opt_args[OPT_ARG_GOTO]);
-			/* peer goes to the same context and extension as chan, so just copy info from chan*/
-			ast_copy_string(peer->context, chan->context, sizeof(peer->context));
-			ast_copy_string(peer->exten, chan->exten, sizeof(peer->exten));
-			peer->priority = chan->priority + 2;
-			ast_pbx_start(peer);
-			hanguptree(outgoing, NULL, ast_test_flag64(&opts, OPT_CANCEL_ELSEWHERE) ? 1 : 0);
-			if (continue_exec)
-				*continue_exec = 1;
-			res = 0;
-			goto done;
-		}
-
 		if (ast_test_flag64(&opts, OPT_CALLEE_MACRO) && !ast_strlen_zero(opt_args[OPT_ARG_CALLEE_MACRO])) {
 			struct ast_app *theapp;
 			const char *macro_result;
@@ -1775,6 +1743,43 @@
 			ast_channel_unlock(peer);
 		}
 
+		ast_log(LOG_NOTICE, "result is %d\n", res);
+
+		if (!res && (!ast_test_flag64(&opts, OPT_ANNOUNCE) || ast_strlen_zero(opt_args[OPT_ARG_ANNOUNCE]))) {
+			res = 0;
+		} else if (!res) {
+			int digit = 0;
+			/* Start autoservice on the other chan */
+			res = ast_autoservice_start(chan);
+			/* Now Stream the File */
+			if (!res)
+				res = ast_streamfile(peer, opt_args[OPT_ARG_ANNOUNCE], peer->language);
+			if (!res) {
+				digit = ast_waitstream(peer, AST_DIGIT_ANY);
+			}
+			/* Ok, done. stop autoservice */
+			res = ast_autoservice_stop(chan);
+			if (digit > 0 && !res)
+				res = ast_senddigit(chan, digit, 0);
+			else
+				res = digit;
+		}
+
+		if (chan && peer && ast_test_flag64(&opts, OPT_GOTO) && !ast_strlen_zero(opt_args[OPT_ARG_GOTO])) {
+			replace_macro_delimiter(opt_args[OPT_ARG_GOTO]);
+			ast_parseable_goto(chan, opt_args[OPT_ARG_GOTO]);
+			/* peer goes to the same context and extension as chan, so just copy info from chan*/
+			ast_copy_string(peer->context, chan->context, sizeof(peer->context));
+			ast_copy_string(peer->exten, chan->exten, sizeof(peer->exten));
+			peer->priority = chan->priority + 2;
+			ast_pbx_start(peer);
+			hanguptree(outgoing, NULL, ast_test_flag64(&opts, OPT_CANCEL_ELSEWHERE) ? 1 : 0);
+			if (continue_exec)
+				*continue_exec = 1;
+			res = 0;
+			goto done;
+		}	
+
 		if (ast_test_flag64(&opts, OPT_CALLEE_GOSUB) && !ast_strlen_zero(opt_args[OPT_ARG_CALLEE_GOSUB])) {
 			struct ast_app *theapp;
 			const char *gosub_result;
